
  -- globals
  t_odd = {}        -- table to collect odd fields(amp)
  t_even = {}       -- table to collect even fields(freq)
  t_all = {}        -- table to collect all fields
  mycntr = 1        -- global var as counter
--++++++++++
-- Convert from CSV string and write to a table as number
function fromCSV (s)
  s = s .. ','        -- ending comma
  local fieldstart = 1   -- local variable
  repeat
      i  = fieldstart
      local nexti = string.find(s, ',', fieldstart)

      if (mycntr % 2 == 1) then
      table.insert(t_odd, mycntr, tonumber(string.sub(s, fieldstart, nexti-1)))
      else
      table.insert(t_even, mycntr, tonumber(string.sub(s, fieldstart, nexti-1)))
      end
      mycntr = mycntr + 1
      fieldstart = nexti + 1
    until fieldstart > string.len(s)

--checking against a nil value being accidentally entered
for i=1, mycntr-1 do
      if(t_odd[i] == nil)then
       t_odd[i] = t_odd[i-1]
      end
end
for i=1,mycntr-1 do
      if (t_even[i] == nil) then
	t_even[i] = t_even[i-1]
      end
end

return t_odd, t_even
end
--++++++++++
-- Do math on table numbers and merge to one table as a string
function tableMath (t, tt)
local ampval = 2.1234
local freqval = 400.0
      --print ("increase amps by", ampval, "\n")
for i=1,mycntr-2 do
      if (i % 2 == 1 and t_odd[i]~= nil) then
		if (t_odd[i] >= 0.01) then
		t_odd[i] = t_odd[i] + ampval --increase gain
		else
		t_odd[i] = t_odd[i]
		end
      --print("i =",i, " num odd = ", t_odd[i])
        t_all[i] = tostring(t_odd[i].. ",")--comma is added to table entry
	--t_all[i] = t_odd[i]
      elseif (i % 2 == 0 and t_even[i] ~= nil) then
		if (t_even[i] >= 400.00 and t_even[i] < 22050) then
		t_even[i] = t_even[i] + freqval --increase gain
		else
		t_even[i] = t_even[i]
		end
       --print("i =",i, " num even = ", t_even[i])
        --t_all[i] = t_even[i]
	t_all[i] = tostring(t_even[i].. ",")--comma is added to table entry
     end --end if
    end --end for

--checking for results
--for i=3200,3300 do
    --print ("mycntr", i, t_all[i])
   --end 
    --print("mycntr = ", mycntr)

--return t_all
return table.concat(t_all)--this makes one string from the table
end --end function

--++++++++++++++++
filename = "Erhu.txt"
file = assert(io.open(filename, "r+"))--a+, or r+
file2 = assert(io.open("Erhu2.txt", "w"))--a+, or r+
stringOne = file:read("*all")    --read it all
	--print("input:\n"..stringOne)
fromCSV(stringOne)
stringTwo=tableMath(t_odd, t_even)
	--print("output:\n"..stringTwo)
file2:write(stringTwo) --write the new data  
file:close()
file2:close()

